diff -cprN head/doc/src/sgml/ref/alter_table.sgml work/doc/src/sgml/ref/alter_table.sgml
*** head/doc/src/sgml/ref/alter_table.sgml	2009-09-18 14:00:41.000000000 +0900
--- work/doc/src/sgml/ref/alter_table.sgml	2009-11-12 16:21:43.258745000 +0900
*************** ALTER TABLE <replaceable class="PARAMETE
*** 61,66 ****
--- 61,68 ----
      NO INHERIT <replaceable class="PARAMETER">parent_table</replaceable>
      OWNER TO <replaceable class="PARAMETER">new_owner</replaceable>
      SET TABLESPACE <replaceable class="PARAMETER">new_tablespace</replaceable>
+     PARTITION BY { RANGE | LIST } ( key [ USING <replaceable class="PARAMETER">operator</replaceable> ] ) [ (...) ]
+     NO PARTITION
  </synopsis>
   </refsynopsisdiv>
  
*************** ALTER TABLE <replaceable class="PARAMETE
*** 444,449 ****
--- 446,473 ----
      </listitem>
     </varlistentry>
  
+    <varlistentry>
+     <term><literal>PARTITION BY</literal></term>
+     <listitem>
+      <para>
+       This form adds a partition key and optional partitions to the table.
+       Inheritance and check constraints are internally added to the partitions.
+       See <xref linkend="sql-createtable"> for more information.
+      </para>
+     </listitem>
+    </varlistentry>
+ 
+    <varlistentry>
+     <term><literal>NO PARTITION</literal></term>
+     <listitem>
+      <para>
+       This form removes the partition key from the table. If the table has
+       some partitions, partition values are also removed but inheritance and
+       check constraints are kept.
+      </para>
+     </listitem>
+    </varlistentry>
+ 
    </variablelist>
    </para>
  
diff -cprN head/doc/src/sgml/ref/create_table.sgml work/doc/src/sgml/ref/create_table.sgml
*** head/doc/src/sgml/ref/create_table.sgml	2009-10-27 22:58:28.000000000 +0900
--- work/doc/src/sgml/ref/create_table.sgml	2009-11-12 16:26:41.847660000 +0900
*************** CREATE [ [ GLOBAL | LOCAL ] { TEMPORARY 
*** 31,36 ****
--- 31,42 ----
  [ WITH ( <replaceable class="PARAMETER">storage_parameter</replaceable> [= <replaceable class="PARAMETER">value</replaceable>] [, ... ] ) | WITH OIDS | WITHOUT OIDS ]
  [ ON COMMIT { PRESERVE ROWS | DELETE ROWS | DROP } ]
  [ TABLESPACE <replaceable class="PARAMETER">tablespace</replaceable> ]
+ [ PARTITION BY { RANGE | LIST } ( key [ USING <replaceable class="PARAMETER">operator</replaceable> ] )
+   [ ( {
+         PARTITION <replaceable class="PARAMETER">partition</replaceable> VALUES LESS THAN { <replaceable class="PARAMETER">value</replaceable> | MAXVALUE }
+       | PARTITION <replaceable class="PARAMETER">partition</replaceable> VALUES [ IN ] [ ( ] { <replaceable class="PARAMETER">value</replaceable> [, ...] | DEFAULT } [ ) ]
+   } ) ]
+ ]
  
  <phrase>where <replaceable class="PARAMETER">column_constraint</replaceable> is:</phrase>
  
*************** CREATE [ [ GLOBAL | LOCAL ] { TEMPORARY 
*** 704,709 ****
--- 710,726 ----
      </listitem>
     </varlistentry>
  
+    <varlistentry>
+     <term><literal>PARTITION BY</literal></term>
+     <listitem>
+      <para>
+       This clause adds a <literal>RANGE</literal> or <literal>LIST</literal>
+       partition key and optional partitions into the table.
+       When a named partition exist as a table, it inherits this table.
+       If not exists, a new table is automatically created and used.
+      </para>
+     </listitem>
+    </varlistentry>
    </variablelist>
  
    <refsect2 id="SQL-CREATETABLE-storage-parameters">
diff -cprN head/src/backend/catalog/Makefile work/src/backend/catalog/Makefile
*** head/src/backend/catalog/Makefile	2009-10-08 07:14:16.000000000 +0900
--- work/src/backend/catalog/Makefile	2009-11-12 09:44:12.345766600 +0900
*************** POSTGRES_BKI_SRCS = $(addprefix $(top_sr
*** 37,43 ****
  	pg_ts_config.h pg_ts_config_map.h pg_ts_dict.h \
  	pg_ts_parser.h pg_ts_template.h \
  	pg_foreign_data_wrapper.h pg_foreign_server.h pg_user_mapping.h \
! 	pg_default_acl.h \
  	toasting.h indexing.h \
      )
  
--- 37,43 ----
  	pg_ts_config.h pg_ts_config_map.h pg_ts_dict.h \
  	pg_ts_parser.h pg_ts_template.h \
  	pg_foreign_data_wrapper.h pg_foreign_server.h pg_user_mapping.h \
! 	pg_default_acl.h pg_partition.h \
  	toasting.h indexing.h \
      )
  
diff -cprN head/src/backend/catalog/dependency.c work/src/backend/catalog/dependency.c
*** head/src/backend/catalog/dependency.c	2009-10-06 04:24:35.000000000 +0900
--- work/src/backend/catalog/dependency.c	2009-11-12 09:44:12.346667260 +0900
***************
*** 41,46 ****
--- 41,47 ----
  #include "catalog/pg_opclass.h"
  #include "catalog/pg_operator.h"
  #include "catalog/pg_opfamily.h"
+ #include "catalog/pg_partition.h"
  #include "catalog/pg_proc.h"
  #include "catalog/pg_rewrite.h"
  #include "catalog/pg_tablespace.h"
*************** static const Oid object_classes[MAX_OCLA
*** 149,155 ****
  	ForeignDataWrapperRelationId,	/* OCLASS_FDW */
  	ForeignServerRelationId,	/* OCLASS_FOREIGN_SERVER */
  	UserMappingRelationId,		/* OCLASS_USER_MAPPING */
! 	DefaultAclRelationId		/* OCLASS_DEFACL */
  };
  
  
--- 150,157 ----
  	ForeignDataWrapperRelationId,	/* OCLASS_FDW */
  	ForeignServerRelationId,	/* OCLASS_FOREIGN_SERVER */
  	UserMappingRelationId,		/* OCLASS_USER_MAPPING */
! 	DefaultAclRelationId,		/* OCLASS_DEFACL */
! 	PartitionRelationId			/* OCLASS_PARTITION */
  };
  
  
*************** doDeletion(const ObjectAddress *object)
*** 1143,1148 ****
--- 1145,1154 ----
  			RemoveDefaultACLById(object->objectId);
  			break;
  
+ 		case OCLASS_PARTITION:
+ 			RemovePartition(object->objectId);
+ 			break;
+ 
  		default:
  			elog(ERROR, "unrecognized object class: %u",
  				 object->classId);
*************** getObjectClass(const ObjectAddress *obje
*** 2066,2071 ****
--- 2072,2081 ----
  		case DefaultAclRelationId:
  			Assert(object->objectSubId == 0);
  			return OCLASS_DEFACL;
+ 
+ 		case PartitionRelationId:
+ 			Assert(object->objectSubId == 0);
+ 			return OCLASS_PARTITION;
  	}
  
  	/* shouldn't get here */
*************** getObjectDescription(const ObjectAddress
*** 2671,2676 ****
--- 2681,2730 ----
  				break;
  			}
  
+ 		case OCLASS_PARTITION:
+ 			{
+ 				Relation	rel;
+ 				ScanKeyData skey[1];
+ 				SysScanDesc rcscan;
+ 				HeapTuple	tup;
+ 				Form_pg_partition partition;
+ 
+ 				rel = heap_open(PartitionRelationId, AccessShareLock);
+ 
+ 				ScanKeyInit(&skey[0],
+ 							Anum_pg_partition_partrelid,
+ 							BTEqualStrategyNumber, F_OIDEQ,
+ 							ObjectIdGetDatum(object->objectId));
+ 
+ 				rcscan = systable_beginscan(rel, PartitionRelidIndexId,
+ 											true, SnapshotNow, 1, skey);
+ 
+ 				tup = systable_getnext(rcscan);
+ 
+ 				if (!HeapTupleIsValid(tup))
+ 					elog(ERROR, "could not find tuple for partition %u",
+ 						 object->objectId);
+ 
+ 				partition = (Form_pg_partition) GETSTRUCT(tup);
+ 
+ 				switch (partition->partkind)
+ 				{
+ 					case PARTITION_BY_RANGE:
+ 						appendStringInfo(&buffer, _("range partition"));
+ 						break;
+ 					case PARTITION_BY_LIST:
+ 						appendStringInfo(&buffer, _("list partition"));
+ 						break;
+ 					default:
+ 						appendStringInfo(&buffer, _("partition"));
+ 						break;
+ 				}
+ 
+ 				systable_endscan(rcscan);
+ 				heap_close(rel, AccessShareLock);
+ 				break;
+ 			}
+ 
  		default:
  			appendStringInfo(&buffer, "unrecognized object %u %u %d",
  							 object->classId,
diff -cprN head/src/backend/catalog/heap.c work/src/backend/catalog/heap.c
*** head/src/backend/catalog/heap.c	2009-10-06 04:24:35.000000000 +0900
--- work/src/backend/catalog/heap.c	2009-11-12 18:38:57.429663172 +0900
***************
*** 43,48 ****
--- 43,49 ----
  #include "catalog/pg_constraint.h"
  #include "catalog/pg_inherits.h"
  #include "catalog/pg_namespace.h"
+ #include "catalog/pg_partition.h"
  #include "catalog/pg_statistic.h"
  #include "catalog/pg_tablespace.h"
  #include "catalog/pg_type.h"
*************** static void StoreConstraints(Relation re
*** 91,99 ****
  static bool MergeWithExistingConstraint(Relation rel, char *ccname, Node *expr,
  							bool allow_merge, bool is_local);
  static void SetRelationNumChecks(Relation rel, int numchecks);
- static Node *cookConstraint(ParseState *pstate,
- 			   Node *raw_constraint,
- 			   char *relname);
  static List *insert_ordered_unique_oid(List *list, Oid datum);
  
  
--- 92,97 ----
*************** cookDefault(ParseState *pstate,
*** 2269,2275 ****
   * Parse state must be set up to recognize any vars that might appear
   * in the expression.
   */
! static Node *
  cookConstraint(ParseState *pstate,
  			   Node *raw_constraint,
  			   char *relname)
--- 2267,2273 ----
   * Parse state must be set up to recognize any vars that might appear
   * in the expression.
   */
! Node *
  cookConstraint(ParseState *pstate,
  			   Node *raw_constraint,
  			   char *relname)
*************** RemoveStatistics(Oid relid, AttrNumber a
*** 2361,2366 ****
--- 2359,2429 ----
  
  
  /*
+  * Remove a pg_partition entry
+  */
+ void
+ RemovePartition(Oid relid)
+ {
+ 	Relation		rel;
+ 	HeapScanDesc	scan;
+ 	ScanKeyData		key;
+ 	HeapTuple		tup;
+ 
+ 	/* DELETE FROM pg_partition WHERE partrelid = :relid */
+ 	rel = heap_open(PartitionRelationId, RowExclusiveLock);
+ 	tup = SearchSysCache(PARTITIONKEY,
+ 						 ObjectIdGetDatum(relid),
+ 						 0, 0, 0);
+ 	if (!HeapTupleIsValid(tup))
+ 		elog(ERROR, "cache lookup failed for partition %u", relid);
+ 	simple_heap_delete(rel, &tup->t_self);
+ 	ReleaseSysCache(tup);
+ 	heap_close(rel, RowExclusiveLock);
+ 
+ 	/* UPDATE pg_inherits SET inhvalues = NULL WHERE inhparent = :relid */
+ 	rel = heap_open(InheritsRelationId, RowExclusiveLock);
+ 	ScanKeyInit(&key,
+ 				Anum_pg_inherits_inhparent,
+ 				BTEqualStrategyNumber, F_OIDEQ,
+ 				ObjectIdGetDatum(relid));
+ 	scan = heap_beginscan(rel, SnapshotNow, 1, &key);
+ 
+ 	while (HeapTupleIsValid(tup = heap_getnext(scan, ForwardScanDirection)))
+ 	{
+ 		Datum	datum;
+ 		bool	isnull;
+ 
+ 		datum = heap_getattr(tup, Anum_pg_inherits_inhvalues,
+ 						 RelationGetDescr(rel), &isnull);
+ 		if (!isnull)
+ 		{
+ 			Datum		values[Natts_pg_inherits];
+ 			bool		nulls[Natts_pg_inherits];
+ 			bool		replaces[Natts_pg_inherits];
+ 			HeapTuple	newtup;
+ 
+ 			MemSet(values, 0, sizeof(values));
+ 			MemSet(nulls, false, sizeof(nulls));
+ 			MemSet(replaces, false, sizeof(replaces));
+ 
+ 			nulls[Anum_pg_inherits_inhvalues - 1] = true;
+ 			replaces[Anum_pg_inherits_inhvalues - 1] = true;
+ 
+ 			newtup = heap_modify_tuple(tup, RelationGetDescr(rel),
+ 										values, nulls, replaces);
+ 			simple_heap_update(rel, &newtup->t_self, newtup);
+ 			CatalogUpdateIndexes(rel, newtup);
+ 
+ 			heap_freetuple(newtup);
+ 		}
+ 	}
+ 	heap_endscan(scan);
+ 
+ 	heap_close(rel, RowExclusiveLock);
+ }
+ 
+ 
+ /*
   * RelationTruncateIndexes - truncate all indexes associated
   * with the heap relation to zero tuples.
   *
diff -cprN head/src/backend/catalog/pg_inherits.c work/src/backend/catalog/pg_inherits.c
*** head/src/backend/catalog/pg_inherits.c	2009-06-11 23:48:55.000000000 +0900
--- work/src/backend/catalog/pg_inherits.c	2009-11-12 17:14:35.627954618 +0900
***************
*** 23,34 ****
--- 23,40 ----
  #include "catalog/pg_class.h"
  #include "catalog/pg_inherits.h"
  #include "catalog/pg_inherits_fn.h"
+ #include "catalog/pg_partition.h"
  #include "parser/parse_type.h"
  #include "storage/lmgr.h"
+ #include "utils/array.h"
+ #include "utils/builtins.h"
  #include "utils/fmgroids.h"
  #include "utils/syscache.h"
+ #include "utils/lsyscache.h"
  #include "utils/tqual.h"
  
+ static List *sort_range_partitions(List *partitions, Oid opcode);
+ static List *sort_list_partitions(List *partitions);
  
  /*
   * find_inheritance_children
*************** typeInheritsFrom(Oid subclassTypeId, Oid
*** 287,289 ****
--- 293,462 ----
  
  	return result;
  }
+ 
+ /*
+  * find_partitions - Gather information of a partition.
+  *
+  * Returns a list of Partition.
+  */
+ List *
+ find_partitions(Oid parentrelId, char *partkind, Node **partkey, Oid *partopr)
+ {
+ 	Relation		inhrel;
+ 	HeapScanDesc	scan;
+ 	ScanKeyData		key[1];
+ 	HeapTuple		tp;
+ 	Datum			datum;
+ 	bool			isnull;
+ 	List		   *partitions = NIL;
+ 	Oid				left_type;
+ 	Oid				right_type;
+ 	int16			typlen;
+ 	bool			typbyval;
+ 	char			typalign;
+ 
+ 	*partkind = 0;
+ 	*partkey = NULL;
+ 	*partopr = InvalidOid;
+ 
+ 	/* Get partition key and operator. */
+ 	tp = SearchSysCache(PARTITIONKEY, ObjectIdGetDatum(parentrelId), 0, 0, 0);
+ 	if (!HeapTupleIsValid(tp))
+ 		return NIL;	/* not partitioned */
+ 
+ 	*partkind = DatumGetChar(SysCacheGetAttr(PARTITIONKEY, tp,
+ 							Anum_pg_partition_partkind, &isnull));
+ 	*partkey = stringToNode(TextDatumGetCString(SysCacheGetAttr(
+ 					PARTITIONKEY, tp, Anum_pg_partition_partkey, &isnull)));
+ 	*partopr = DatumGetObjectId(SysCacheGetAttr(PARTITIONKEY, tp,
+ 							Anum_pg_partition_partopr, &isnull));
+ 	ReleaseSysCache(tp);
+ 
+ 	op_input_types(*partopr, &left_type, &right_type);
+ 	get_typlenbyvalalign(left_type, &typlen, &typbyval, &typalign);
+ 
+ 	if (has_subclass(parentrelId))
+ 	{
+ 		/* Gather values from existing paritition. */
+ 		inhrel = heap_open(InheritsRelationId, AccessShareLock);
+ 		ScanKeyInit(&key[0],
+ 					Anum_pg_inherits_inhparent,
+ 					BTEqualStrategyNumber, F_OIDEQ,
+ 					ObjectIdGetDatum(parentrelId));
+ 		scan = heap_beginscan(inhrel, SnapshotNow, 1, key);
+ 
+ 		while ((tp = heap_getnext(scan, ForwardScanDirection)) != NULL)
+ 		{
+ 			Form_pg_inherits	inh = (Form_pg_inherits) GETSTRUCT(tp);
+ 			Partition	   *p;
+ 
+ 			datum = heap_getattr(tp, Anum_pg_inherits_inhvalues,
+ 							 RelationGetDescr(inhrel), &isnull);
+ 			if (isnull)
+ 				continue;	/* non-partition inheritance */
+ 
+ 			p = (Partition *) palloc(sizeof(Partition));
+ 			p->relid = inh->inhrelid;
+ 			deconstruct_array(DatumGetArrayTypeP(datum), left_type, typlen,
+ 							typbyval, typalign, &p->values, NULL, &p->nvalues);
+ 
+ 			partitions = lappend(partitions, p);
+ 		}
+ 
+ 		heap_endscan(scan);
+ 		heap_close(inhrel, AccessShareLock);
+ 
+ 		switch (*partkind)
+ 		{
+ 			case PARTITION_BY_RANGE:
+ 				partitions = sort_range_partitions(partitions,
+ 												   get_opcode(*partopr));
+ 				break;
+ 			case PARTITION_BY_LIST:
+ 				partitions = sort_list_partitions(partitions);
+ 				break;
+ 		}
+ 	}
+ 
+ 	return partitions;
+ }
+ 
+ /* overflow partition is always larger than normal partitions. */
+ static int
+ compare_range_partitions(const Partition *lhs,
+ 						 const Partition *rhs,
+ 						 FmgrInfo *ltfn)
+ {
+ 	if (lhs->nvalues == 0 && rhs->nvalues == 0)
+ 		return 0;	/* should not ocuur */
+ 	else if (rhs->nvalues == 0)
+ 		return -1;	/* rhs is overflow partition */
+ 	else if (lhs->nvalues == 0)
+ 		return +1;	/* lhs is overflow partition */
+ 	else if (DatumGetBool(FunctionCall2(ltfn, lhs->values[0], rhs->values[0])))
+ 		return -1;	/* lhs < rhs */
+ 	else if (DatumGetBool(FunctionCall2(ltfn, rhs->values[0], lhs->values[0])))
+ 		return +1;	/* rhs < lhs */
+ 	else
+ 		return 0;
+ }
+ 
+ static List *
+ sort_range_partitions(List *partitions, Oid opcode)
+ {
+ 	FmgrInfo		ltfn;
+ 	Partition **arr;
+ 	ListCell	   *cell;
+ 	int				n;
+ 	int				i;
+ 	List		   *sorted = NIL;
+ 
+ 	if (list_length(partitions) < 2)
+ 		return partitions;	/* no need to sort */
+ 
+ 	fmgr_info(opcode, &ltfn);
+ 	n = list_length(partitions);
+ 	arr = (Partition **) palloc(sizeof(Partition *) * n);
+ 
+ 	/*
+ 	 * Sort upper range using partition operator. We flatten list to array,
+ 	 * sort items in array, and rebuild a list.
+ 	 */
+ 	i = 0;
+ 	foreach(cell, partitions)
+ 		arr[i++] = (Partition *) lfirst(cell);
+ 	qsort_arg(arr, n, sizeof(Partition *),
+ 		(qsort_arg_comparator) compare_range_partitions, &ltfn);
+ 	for (i = 0; i < n; i++)
+ 		sorted = lappend(sorted, arr[i]);
+ 	pfree(arr);
+ 
+ 	return sorted;
+ }
+ 
+ static List *
+ sort_list_partitions(List *partitions)
+ {
+ 	ListCell   *cell;
+ 	ListCell   *prev;
+ 
+ 	if (list_length(partitions) < 2)
+ 		return partitions;	/* no need to sort */
+ 
+ 	/* We only have to move the oveflow partition at the end of list. */
+ 	for (prev = NULL, cell = list_head(partitions);
+ 		 cell != NULL;
+ 		 prev = cell, cell = lnext(prev))
+ 	{
+ 		Partition *p = (Partition *) lfirst(cell);
+ 
+ 		if (p->nvalues == 0)
+ 		{
+ 			partitions = list_delete_cell(partitions, cell, prev);
+ 			partitions = lappend(partitions, p);
+ 			break;
+ 		}
+ 	}
+ 
+ 	return partitions;
+ }
